package com.framework.app.converter

import okhttp3.ResponseBody
import retrofit2.Converter
import retrofit2.Retrofit
import java.lang.reflect.Type

/**
 * 字节流转换器
 */
class ByteArrayConverterFactory : Converter.Factory() {
    override fun responseBodyConverter(
        type: Type,
        annotations: Array<out Annotation>,
        retrofit: Retrofit
    ): Converter<ResponseBody, *>? {
        if (type.typeName == "byte[]") {
            return Converter<ResponseBody, ByteArray> { value -> value.bytes() }
        }
        return null
    }
}