package com.sybotan.android.demo.tools

import android.app.ProgressDialog
import android.content.Context
import android.content.Intent
import android.net.Uri
import android.os.Build
import android.os.Environment
import android.os.Handler
import android.os.Message
import androidx.core.content.FileProvider
import java.io.*
import java.lang.Exception
import java.net.HttpURLConnection
import java.net.URL
import java.nio.ByteBuffer
import java.nio.charset.Charset

class DownLoadApk(private val dialog: ProgressDialog, var url: String, var context: Context, build: String) : Runnable {
    var `is`: InputStream? = null
    var fos: FileOutputStream? = null
    var build: String

    //  判断是否停止
    private val mIsCancel = false

    //  进度
    private var mProgress = 0

    //  文件保存路径
    private val mSavePath: String? = null
    override fun run() {
        try {
            if (Environment.getExternalStorageState() == Environment.MEDIA_MOUNTED) {
                val dir = context.getExternalFilesDir("meos")
                if (!dir!!.exists()) {
                    dir.mkdir()
                }
                // 下载文件
                val conn = URL(url).openConnection() as HttpURLConnection
                conn.connect()
                val `is` = conn.inputStream
                val length = conn.contentLength
                val outputStream = FileOutputStream("$dir/$build")
                val byteArray = ByteArray(1024)
                var count: Int
                var progress = 0f
                do {
                    count = `is`.read(byteArray)
                    if (count != -1) {
                        outputStream.write(byteArray, 0, count)
                        progress += count
                        mProgress = ((progress / length) * 100f).toInt()
                        mUpdateProgressHandler.sendEmptyMessage(1)
                    } else {
                        `is`.close()
                        outputStream.close()
                        break
                    }
                } while (true)
                mUpdateProgressHandler.sendEmptyMessage(2)
                `is`.close()
                outputStream.close()

            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    /**
     * 接收消息
     */
    private val mUpdateProgressHandler: Handler = object : Handler() {
        override fun handleMessage(msg: Message) {
            when (msg.what) {
                1 ->                     // 设置进度条
                    dialog.progress = mProgress
                2 -> {
                    // 隐藏当前下载对话框
                    dialog.dismiss()
                    // 安装 APK 文件
                    installAPK()
                }
            }
        }
    }

    protected fun installAPK() {
        val dir = context.getExternalFilesDir("meos")
        //        File apkFile = new File(mSavePath, build);
        val apkFile = File(dir, build)
        if (!apkFile.exists()) {
            return
        }
        val intent = Intent(Intent.ACTION_VIEW)
        intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            //区别于 FLAG_GRANT_READ_URI_PERMISSION 跟 FLAG_GRANT_WRITE_URI_PERMISSION， URI权限会持久存在即使重启，直到明确的用 revokeUriPermission(Uri, int) 撤销。 这个flag只提供可能持久授权。但是接收的应用必须调用ContentResolver的takePersistableUriPermission(Uri, int)方法实现
            val apkUri = FileProvider.getUriForFile(context, "com.sybotan.android.demo.fileProvider", apkFile) //与manifest中定义的provider中的authorities="com.xxxx.fileprovider"保持一致
            intent.setDataAndType(apkUri, "application/vnd.android.package-archive")
        } else {
            intent.setDataAndType(Uri.fromFile(apkFile), "application/vnd.android.package-archive")
        }
        intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION or Intent.FLAG_GRANT_PERSISTABLE_URI_PERMISSION)
        intent.addCategory("android.intent.category.DEFAULT")
        intent.action = "android.intent.action.VIEW"
        context.startActivity(intent)
    }

    companion object {
        fun getChars(bytes: ByteArray): CharArray {
            val cs = Charset.forName("UTF-8")
            val bb = ByteBuffer.allocate(bytes.size)
            bb.put(bytes).flip()
            val cb = cs.decode(bb)
            return cb.array()
        }
    }

    init {
        this.build = "$build.apk"
    }
}